标签:range ota 网上 not back amp orm || star
Given an array nums
of integers, you can perform operations on the array.
In each operation, you pick any nums[i]
and delete it to earn nums[i]
points. After, you must delete every element equal to nums[i] - 1
or nums[i] + 1
.
You start with 0 points. Return the maximum number of points you can earn by applying such operations.
Example 1:
Input: nums = [3, 4, 2] Output: 6 Explanation: Delete 4 to earn 4 points, consequently 3 is also deleted. Then, delete 2 to earn 2 points. 6 total points are earned.
Example 2:
Input: nums = [2, 2, 3, 3, 3, 4] Output: 9 Explanation: Delete 3 to earn 3 points, deleting both 2‘s and the 4. Then, delete 3 again to earn 3 points, and 3 again to earn 3 points. 9 total points are earned.
Note:
nums
is at most 20000
.nums[i]
is an integer in the range [1, 10000]
.【思路】这道题初看觉得就是求每个连续区间奇偶分别求和的大者,然后仔细一看才发现是和之前HouseRobber一样的题目。
我自己写的时候把每个连续区间分离出来然后分别调用HouseRobber的DP函数最后求和,速度慢了一点。
看了网上其他解答才发现整个数字区间可以直接表示出来,然后调用一次HouseRobber的DP算法就好了。
自己的代码:
class Solution { public: int deleteAndEarn(vector<int>& nums) { map<int,int> d; for(auto i:nums){ d[i] += 1; } int res = 0; auto it = d.begin(); while(it != d.end()){ vector<int> temp; while(1){ temp.push_back(it->first * it->second); auto pre = it->first; if(++it == d.end() || pre != it->first - 1) break; } res += maxGet(temp); } return res; } int maxGet(vector<int> & num){ int s = num.size(); vector<int> dp(s+1,0); dp[1] = num[0]; for(int i = 2; i<=s; ++i){ dp[i] = max(dp[i-1],dp[i-2] + num[i-1]); } return dp[s]; } };
更快的代码:
class Solution { public: int deleteAndEarn(vector<int>& nums) { vector<int> sums(10001, 0); for (int num : nums) sums[num] += num; for (int i = 2; i < 10001; ++i) { sums[i] = max(sums[i - 1], sums[i - 2] + sums[i]); } return sums[10000]; } };
leetcode 740. Delete and Earn题解
标签:range ota 网上 not back amp orm || star
原文地址:https://www.cnblogs.com/J1ac/p/9610317.html